#!/usr/bin/env python
#
#       genapi.py
#       
#       Copyright 2008 Nick Treleaven <nick.treleaven<at>btinternet.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

import re

def get_function_names():
	names = []
	f = open('plugins.c')
	while 1:
		l = f.readline()
		if l == "":
			break;
		m = re.match("^\t&([a-z_]+)", l)
		if m:
			s = m.group(1)
			if not s.endswith('_funcs'):
				names.append(s)
	f.close
	return names

def get_api_tuple(str):
	m = re.match("^([a-z]+)_([a-z_]+)$", str)
	return 'p_' + m.group(1), m.group(2)

outfile = 'geanyfunctions.h'
f = open(outfile, 'w')
fnames = get_function_names()
for fname in fnames:
	ptr, name = get_api_tuple(fname)
	print >>f, '#define ' + fname + ' \\\n\t' + ptr + '->' + name
f.close

print 'Generated ' + outfile
